/* file: "main.c" */

/* Copyright (C) 1994, 1995 by Marc Feeley, All Rights Reserved. */

/* This is the driver of the Gambit-C system */

#define ___VERSION 4
#include "gambit.h"
___BEGIN_MODULE

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#include "setup.h"

void usage_err( argv )
char *argv[];
{
  fprintf( stderr, "Usage: %s [-:OPT,OPT...] ...\n", argv[0] );
  fprintf( stderr, "  where OPT can be one of:\n" );
  fprintf( stderr, "    sSTACK_SIZE_IN_KILOBYTES\n" );
  fprintf( stderr, "    hHEAP_SIZE_IN_KILOBYTES\n" );
  fprintf( stderr, "    d\n" );
  exit(1);
}

void main( argc, argv )
int argc;
char **argv;
{
  int stack_len_in_k, heap_len_in_k;

  /* handle arguments to runtime */

  stack_len_in_k = 0; /* To select default */
  heap_len_in_k  = 0; /* To select default */

  if (argc > 1)
    {
      char *s, *arg = argv[1];
      if ((*arg++ == '-') && (*arg == ':'))
	{
	  *arg = ',';
	  while (*arg++ == ',')
	    {
	      s = arg++;
	      switch (*s)
		{
		case 's':
		case 'h':
		  {
		    char temp;
		    int argval;
		    while (isdigit(*arg)) arg++;
		    temp = *arg;
		    *arg = '\0';
		    argval = atoi(s+1);
		    *arg = temp;
		    switch (*s)
		      {
		      case 's': stack_len_in_k = argval; break;
		      case 'h': heap_len_in_k  = argval; break;
		      }
		    break;
		  }
		case 'd':
		  debug_level = 1;
		  break;
		default:
		  usage_err( argv );
		}
	    }
	  if (*--arg != '\0')
	    usage_err( argv );
          argv[1] = argv[0];
          argc--;
          argv++;
	}
    }

  /* do system setup */

  gambit_setup( argc, argv, stack_len_in_k, heap_len_in_k );

  /* run the program */

  while (gambit_alive())
    gambit_run();

  exit(0);
}
